/*
 @licstart  The following is the entire license notice for the JavaScript code in this page.

 Copyright (C) 2014-2020, Josef Hahn

 This file is part of Yaji.

 Yaji is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Yaji is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Yaji.  If not, see <http://www.gnu.org/licenses/>.

 @licend  The above is the entire license notice for the JavaScript code in this page.
*/


class MyWidget extends clove.Widget {

    constructor(config, domnode) {
        super(clove.utils.applyDefaultsToConfig(config, {
            hstretch: 1,
            vstretch: 1,
        }), domnode);
        this.declareProperty('angle', 0);
        this._txtnode = $.parseHTML("<div style='position:absolute;top:50%;left:50%'></div>")[0];
        this._txtnode.textContent = "このカーペットは買いたくない。";
        this.contentnode.appendChild(this._txtnode);
    }

    angle_setter(v) {
        v = (v||0) % 360;
        this._txtnode.style.transform = `translate(-50%, -50%) rotate(${v}deg)`;
    }

}
