#!/usr/bin/python3

# Copyright (C) 2014-2020, Josef Hahn
#
# This file is part of Yaji.
#
# Yaji is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Yaji is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Yaji.  If not, see <http://www.gnu.org/licenses/>.

import ___sampleapp  # this is just an internal hack - just ignore it and don't copy it!

import time

import yaji


class Application(yaji.Application):

    iterations = 2000

    def __init__(self):
        super().__init__(head1="Yaji Sample", head2="benchmark", stop_implicitly_when_browser_closed=True)
        self.appconfig.setconfig("X", -1)
        self.setbodyleft(yaji.View(label="", busy=True, vstretch=1, hstretch=1))
        self.starttime = None

    @yaji.RequestHandler.for_urls(auto=True)
    def _do_something(self, X: int):
        if X == 0:
            self.starttime = time.time()
        if X == self.iterations:
            dur = time.time() - self.starttime
            self.setbodyleft(yaji.View(label=f"{self.iterations} iterations in {dur:.3f}s.\n"
                                             f"{self.iterations/dur:.3f} iterations/s."))
        else:
            self.appconfig.setconfig("X", X)


if __name__ == '__main__':
    Application().start()
