#!/usr/bin/python3

# Copyright (C) 2014-2020, Josef Hahn
#
# This file is part of Yaji.
#
# Yaji is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Yaji is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Yaji.  If not, see <http://www.gnu.org/licenses/>.

import ___sampleapp  # this is just an internal hack - just ignore it and don't copy it!

import datetime

import yaji


class Application(yaji.Application):

    def __init__(self):
        super().__init__(head1="Yaji Sample", head2="requesthandler", stop_implicitly_when_browser_closed=True)
        funcargs = {'foo': "Foo!", 'bar': 1337, 'baz': datetime.datetime.now()}
        self.setbodyleft(yaji.View('Button', label=f"Go",
                                   OnClicked=self.bindevent(yaji.BackendFunction('something', funcargs))))

    @yaji.RequestHandler.for_urls(auto=True)
    def _do_something(self, foo: str, bar: float, baz: datetime.datetime):
        self.setbodyleft(yaji.View('Label', label=f"""
foo: {repr(foo)}
bar: {repr(bar)}
baz: {baz}
"""))


if __name__ == '__main__':
    Application().start()
