#!/usr/bin/python3

# Copyright (C) 2014-2020, Josef Hahn
#
# This file is part of Yaji.
#
# Yaji is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Yaji is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Yaji.  If not, see <http://www.gnu.org/licenses/>.

import ___sampleapp  # this is just an internal hack - just ignore it and don't copy it!

import yaji


class ApplicationA(yaji.Application):

    def __init__(self):
        super().__init__(head1="Yaji Sample", head2="takeover a", stop_implicitly_when_browser_closed=True)
        self.setbodyleft(yaji.View('Button', label="Start b",
                                   OnClicked=self.bindevent(yaji.BackendFunction('start_b'))))

    @yaji.RequestHandler.for_urls(auto=True)
    def _do_start_b(self):
        ApplicationB(self).start()


class ApplicationB(yaji.Application):

    def __init__(self, parent):
        super().__init__(head1="Yaji Sample", head2="takeover b", stop_implicitly_when_browser_closed=True,
                         parentid=parent.id)
        self.setbodyleft(yaji.View('Button', label="Stop b", OnClicked=self.bindevent(yaji.BackendFunction('stop'))))
        self.setbodyright(yaji.View('Button', label="Start c",
                                    OnClicked=self.bindevent(yaji.BackendFunction('start_c'))))

    @yaji.RequestHandler.for_urls(auto=True)
    def _do_stop(self):
        self.stop()

    @yaji.RequestHandler.for_urls(auto=True)
    def _do_start_c(self):
        ApplicationC(self).start()


class ApplicationC(yaji.Application):

    def __init__(self, parent):
        super().__init__(head1="Yaji Sample", head2="takeover c", stop_implicitly_when_browser_closed=True,
                         parentid=parent.id)
        self.setbodyleft(yaji.View('Button', label="Stop c", OnClicked=self.bindevent(yaji.BackendFunction('stop'))))

    @yaji.RequestHandler.for_urls(auto=True)
    def _do_stop(self):
        self.stop()


if __name__ == '__main__':
    ApplicationA().start()
